t / test-lib-functions.shon commit t5310: increase the number of bitmapped commits (1ac96cd)
   1# Library of functions shared by all tests scripts, included by
   2# test-lib.sh.
   3#
   4# Copyright (c) 2005 Junio C Hamano
   5#
   6# This program is free software: you can redistribute it and/or modify
   7# it under the terms of the GNU General Public License as published by
   8# the Free Software Foundation, either version 2 of the License, or
   9# (at your option) any later version.
  10#
  11# This program is distributed in the hope that it will be useful,
  12# but WITHOUT ANY WARRANTY; without even the implied warranty of
  13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  14# GNU General Public License for more details.
  15#
  16# You should have received a copy of the GNU General Public License
  17# along with this program.  If not, see http://www.gnu.org/licenses/ .
  18
  19# The semantics of the editor variables are that of invoking
  20# sh -c "$EDITOR \"$@\"" files ...
  21#
  22# If our trash directory contains shell metacharacters, they will be
  23# interpreted if we just set $EDITOR directly, so do a little dance with
  24# environment variables to work around this.
  25#
  26# In particular, quoting isn't enough, as the path may contain the same quote
  27# that we're using.
  28test_set_editor () {
  29        FAKE_EDITOR="$1"
  30        export FAKE_EDITOR
  31        EDITOR='"$FAKE_EDITOR"'
  32        export EDITOR
  33}
  34
  35test_set_index_version () {
  36    GIT_INDEX_VERSION="$1"
  37    export GIT_INDEX_VERSION
  38}
  39
  40test_decode_color () {
  41        awk '
  42                function name(n) {
  43                        if (n == 0) return "RESET";
  44                        if (n == 1) return "BOLD";
  45                        if (n == 2) return "FAINT";
  46                        if (n == 3) return "ITALIC";
  47                        if (n == 7) return "REVERSE";
  48                        if (n == 30) return "BLACK";
  49                        if (n == 31) return "RED";
  50                        if (n == 32) return "GREEN";
  51                        if (n == 33) return "YELLOW";
  52                        if (n == 34) return "BLUE";
  53                        if (n == 35) return "MAGENTA";
  54                        if (n == 36) return "CYAN";
  55                        if (n == 37) return "WHITE";
  56                        if (n == 40) return "BLACK";
  57                        if (n == 41) return "BRED";
  58                        if (n == 42) return "BGREEN";
  59                        if (n == 43) return "BYELLOW";
  60                        if (n == 44) return "BBLUE";
  61                        if (n == 45) return "BMAGENTA";
  62                        if (n == 46) return "BCYAN";
  63                        if (n == 47) return "BWHITE";
  64                }
  65                {
  66                        while (match($0, /\033\[[0-9;]*m/) != 0) {
  67                                printf "%s<", substr($0, 1, RSTART-1);
  68                                codes = substr($0, RSTART+2, RLENGTH-3);
  69                                if (length(codes) == 0)
  70                                        printf "%s", name(0)
  71                                else {
  72                                        n = split(codes, ary, ";");
  73                                        sep = "";
  74                                        for (i = 1; i <= n; i++) {
  75                                                printf "%s%s", sep, name(ary[i]);
  76                                                sep = ";"
  77                                        }
  78                                }
  79                                printf ">";
  80                                $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
  81                        }
  82                        print
  83                }
  84        '
  85}
  86
  87lf_to_nul () {
  88        perl -pe 'y/\012/\000/'
  89}
  90
  91nul_to_q () {
  92        perl -pe 'y/\000/Q/'
  93}
  94
  95q_to_nul () {
  96        perl -pe 'y/Q/\000/'
  97}
  98
  99q_to_cr () {
 100        tr Q '\015'
 101}
 102
 103q_to_tab () {
 104        tr Q '\011'
 105}
 106
 107qz_to_tab_space () {
 108        tr QZ '\011\040'
 109}
 110
 111append_cr () {
 112        sed -e 's/$/Q/' | tr Q '\015'
 113}
 114
 115remove_cr () {
 116        tr '\015' Q | sed -e 's/Q$//'
 117}
 118
 119# Generate an output of $1 bytes of all zeroes (NULs, not ASCII zeroes).
 120# If $1 is 'infinity', output forever or until the receiving pipe stops reading,
 121# whichever comes first.
 122generate_zero_bytes () {
 123        test-tool genzeros "$@"
 124}
 125
 126# In some bourne shell implementations, the "unset" builtin returns
 127# nonzero status when a variable to be unset was not set in the first
 128# place.
 129#
 130# Use sane_unset when that should not be considered an error.
 131
 132sane_unset () {
 133        unset "$@"
 134        return 0
 135}
 136
 137test_tick () {
 138        if test -z "${test_tick+set}"
 139        then
 140                test_tick=1112911993
 141        else
 142                test_tick=$(($test_tick + 60))
 143        fi
 144        GIT_COMMITTER_DATE="$test_tick -0700"
 145        GIT_AUTHOR_DATE="$test_tick -0700"
 146        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 147}
 148
 149# Stop execution and start a shell. This is useful for debugging tests.
 150#
 151# Be sure to remove all invocations of this command before submitting.
 152
 153test_pause () {
 154        "$SHELL_PATH" <&6 >&5 2>&7
 155}
 156
 157# Wrap git with a debugger. Adding this to a command can make it easier
 158# to understand what is going on in a failing test.
 159#
 160# Examples:
 161#     debug git checkout master
 162#     debug --debugger=nemiver git $ARGS
 163#     debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
 164debug () {
 165        case "$1" in
 166        -d)
 167                GIT_DEBUGGER="$2" &&
 168                shift 2
 169                ;;
 170        --debugger=*)
 171                GIT_DEBUGGER="${1#*=}" &&
 172                shift 1
 173                ;;
 174        *)
 175                GIT_DEBUGGER=1
 176                ;;
 177        esac &&
 178        GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7
 179}
 180
 181# Call test_commit with the arguments
 182# [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
 183#
 184# This will commit a file with the given contents and the given commit
 185# message, and tag the resulting commit with the given tag name.
 186#
 187# <file>, <contents>, and <tag> all default to <message>.
 188#
 189# If the first argument is "-C", the second argument is used as a path for
 190# the git invocations.
 191
 192test_commit () {
 193        notick= &&
 194        signoff= &&
 195        indir= &&
 196        while test $# != 0
 197        do
 198                case "$1" in
 199                --notick)
 200                        notick=yes
 201                        ;;
 202                --signoff)
 203                        signoff="$1"
 204                        ;;
 205                -C)
 206                        indir="$2"
 207                        shift
 208                        ;;
 209                *)
 210                        break
 211                        ;;
 212                esac
 213                shift
 214        done &&
 215        indir=${indir:+"$indir"/} &&
 216        file=${2:-"$1.t"} &&
 217        echo "${3-$1}" > "$indir$file" &&
 218        git ${indir:+ -C "$indir"} add "$file" &&
 219        if test -z "$notick"
 220        then
 221                test_tick
 222        fi &&
 223        git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
 224        git ${indir:+ -C "$indir"} tag "${4:-$1}"
 225}
 226
 227# Call test_merge with the arguments "<message> <commit>", where <commit>
 228# can be a tag pointing to the commit-to-merge.
 229
 230test_merge () {
 231        test_tick &&
 232        git merge -m "$1" "$2" &&
 233        git tag "$1"
 234}
 235
 236# Efficiently create <nr> commits, each with a unique number (from 1 to <nr>
 237# by default) in the commit message.
 238#
 239# Usage: test_commit_bulk [options] <nr>
 240#   -C <dir>:
 241#       Run all git commands in directory <dir>
 242#   --ref=<n>:
 243#       ref on which to create commits (default: HEAD)
 244#   --start=<n>:
 245#       number commit messages from <n> (default: 1)
 246#   --message=<msg>:
 247#       use <msg> as the commit mesasge (default: "commit %s")
 248#   --filename=<fn>:
 249#       modify <fn> in each commit (default: %s.t)
 250#   --contents=<string>:
 251#       place <string> in each file (default: "content %s")
 252#   --id=<string>:
 253#       shorthand to use <string> and %s in message, filename, and contents
 254#
 255# The message, filename, and contents strings are evaluated by printf, with the
 256# first "%s" replaced by the current commit number. So you can do:
 257#
 258#   test_commit_bulk --filename=file --contents="modification %s"
 259#
 260# to have every commit touch the same file, but with unique content.
 261#
 262test_commit_bulk () {
 263        tmpfile=.bulk-commit.input
 264        indir=.
 265        ref=HEAD
 266        n=1
 267        message='commit %s'
 268        filename='%s.t'
 269        contents='content %s'
 270        while test $# -gt 0
 271        do
 272                case "$1" in
 273                -C)
 274                        indir=$2
 275                        shift
 276                        ;;
 277                --ref=*)
 278                        ref=${1#--*=}
 279                        ;;
 280                --start=*)
 281                        n=${1#--*=}
 282                        ;;
 283                --message=*)
 284                        message=${1#--*=}
 285                        ;;
 286                --filename=*)
 287                        filename=${1#--*=}
 288                        ;;
 289                --contents=*)
 290                        contents=${1#--*=}
 291                        ;;
 292                --id=*)
 293                        message="${1#--*=} %s"
 294                        filename="${1#--*=}-%s.t"
 295                        contents="${1#--*=} %s"
 296                        ;;
 297                -*)
 298                        BUG "invalid test_commit_bulk option: $1"
 299                        ;;
 300                *)
 301                        break
 302                        ;;
 303                esac
 304                shift
 305        done
 306        total=$1
 307
 308        add_from=
 309        if git -C "$indir" rev-parse --verify "$ref"
 310        then
 311                add_from=t
 312        fi
 313
 314        while test "$total" -gt 0
 315        do
 316                test_tick &&
 317                echo "commit $ref"
 318                printf 'author %s <%s> %s\n' \
 319                        "$GIT_AUTHOR_NAME" \
 320                        "$GIT_AUTHOR_EMAIL" \
 321                        "$GIT_AUTHOR_DATE"
 322                printf 'committer %s <%s> %s\n' \
 323                        "$GIT_COMMITTER_NAME" \
 324                        "$GIT_COMMITTER_EMAIL" \
 325                        "$GIT_COMMITTER_DATE"
 326                echo "data <<EOF"
 327                printf "$message\n" $n
 328                echo "EOF"
 329                if test -n "$add_from"
 330                then
 331                        echo "from $ref^0"
 332                        add_from=
 333                fi
 334                printf "M 644 inline $filename\n" $n
 335                echo "data <<EOF"
 336                printf "$contents\n" $n
 337                echo "EOF"
 338                echo
 339                n=$((n + 1))
 340                total=$((total - 1))
 341        done >"$tmpfile"
 342
 343        git -C "$indir" \
 344            -c fastimport.unpacklimit=0 \
 345            fast-import <"$tmpfile" || return 1
 346
 347        # This will be left in place on failure, which may aid debugging.
 348        rm -f "$tmpfile"
 349
 350        # If we updated HEAD, then be nice and update the index and working
 351        # tree, too.
 352        if test "$ref" = "HEAD"
 353        then
 354                git -C "$indir" checkout -f HEAD || return 1
 355        fi
 356
 357}
 358
 359# This function helps systems where core.filemode=false is set.
 360# Use it instead of plain 'chmod +x' to set or unset the executable bit
 361# of a file in the working directory and add it to the index.
 362
 363test_chmod () {
 364        chmod "$@" &&
 365        git update-index --add "--chmod=$@"
 366}
 367
 368# Get the modebits from a file.
 369test_modebits () {
 370        ls -l "$1" | sed -e 's|^\(..........\).*|\1|'
 371}
 372
 373# Unset a configuration variable, but don't fail if it doesn't exist.
 374test_unconfig () {
 375        config_dir=
 376        if test "$1" = -C
 377        then
 378                shift
 379                config_dir=$1
 380                shift
 381        fi
 382        git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
 383        config_status=$?
 384        case "$config_status" in
 385        5) # ok, nothing to unset
 386                config_status=0
 387                ;;
 388        esac
 389        return $config_status
 390}
 391
 392# Set git config, automatically unsetting it after the test is over.
 393test_config () {
 394        config_dir=
 395        if test "$1" = -C
 396        then
 397                shift
 398                config_dir=$1
 399                shift
 400        fi
 401        test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
 402        git ${config_dir:+-C "$config_dir"} config "$@"
 403}
 404
 405test_config_global () {
 406        test_when_finished "test_unconfig --global '$1'" &&
 407        git config --global "$@"
 408}
 409
 410write_script () {
 411        {
 412                echo "#!${2-"$SHELL_PATH"}" &&
 413                cat
 414        } >"$1" &&
 415        chmod +x "$1"
 416}
 417
 418# Use test_set_prereq to tell that a particular prerequisite is available.
 419# The prerequisite can later be checked for in two ways:
 420#
 421# - Explicitly using test_have_prereq.
 422#
 423# - Implicitly by specifying the prerequisite tag in the calls to
 424#   test_expect_{success,failure,code}.
 425#
 426# The single parameter is the prerequisite tag (a simple word, in all
 427# capital letters by convention).
 428
 429test_unset_prereq () {
 430        ! test_have_prereq "$1" ||
 431        satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
 432}
 433
 434test_set_prereq () {
 435        if test -n "$GIT_TEST_FAIL_PREREQS"
 436        then
 437                case "$1" in
 438                # The "!" case is handled below with
 439                # test_unset_prereq()
 440                !*)
 441                        ;;
 442                # (Temporary?) whitelist of things we can't easily
 443                # pretend not to support
 444                SYMLINKS)
 445                        ;;
 446                # Inspecting whether GIT_TEST_FAIL_PREREQS is on
 447                # should be unaffected.
 448                FAIL_PREREQS)
 449                        ;;
 450                *)
 451                        return
 452                esac
 453        fi
 454
 455        case "$1" in
 456        !*)
 457                test_unset_prereq "${1#!}"
 458                ;;
 459        *)
 460                satisfied_prereq="$satisfied_prereq$1 "
 461                ;;
 462        esac
 463}
 464satisfied_prereq=" "
 465lazily_testable_prereq= lazily_tested_prereq=
 466
 467# Usage: test_lazy_prereq PREREQ 'script'
 468test_lazy_prereq () {
 469        lazily_testable_prereq="$lazily_testable_prereq$1 "
 470        eval test_prereq_lazily_$1=\$2
 471}
 472
 473test_run_lazy_prereq_ () {
 474        script='
 475mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
 476(
 477        cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
 478)'
 479        say >&3 "checking prerequisite: $1"
 480        say >&3 "$script"
 481        test_eval_ "$script"
 482        eval_ret=$?
 483        rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
 484        if test "$eval_ret" = 0; then
 485                say >&3 "prerequisite $1 ok"
 486        else
 487                say >&3 "prerequisite $1 not satisfied"
 488        fi
 489        return $eval_ret
 490}
 491
 492test_have_prereq () {
 493        # prerequisites can be concatenated with ','
 494        save_IFS=$IFS
 495        IFS=,
 496        set -- $*
 497        IFS=$save_IFS
 498
 499        total_prereq=0
 500        ok_prereq=0
 501        missing_prereq=
 502
 503        for prerequisite
 504        do
 505                case "$prerequisite" in
 506                !*)
 507                        negative_prereq=t
 508                        prerequisite=${prerequisite#!}
 509                        ;;
 510                *)
 511                        negative_prereq=
 512                esac
 513
 514                case " $lazily_tested_prereq " in
 515                *" $prerequisite "*)
 516                        ;;
 517                *)
 518                        case " $lazily_testable_prereq " in
 519                        *" $prerequisite "*)
 520                                eval "script=\$test_prereq_lazily_$prerequisite" &&
 521                                if test_run_lazy_prereq_ "$prerequisite" "$script"
 522                                then
 523                                        test_set_prereq $prerequisite
 524                                fi
 525                                lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
 526                        esac
 527                        ;;
 528                esac
 529
 530                total_prereq=$(($total_prereq + 1))
 531                case "$satisfied_prereq" in
 532                *" $prerequisite "*)
 533                        satisfied_this_prereq=t
 534                        ;;
 535                *)
 536                        satisfied_this_prereq=
 537                esac
 538
 539                case "$satisfied_this_prereq,$negative_prereq" in
 540                t,|,t)
 541                        ok_prereq=$(($ok_prereq + 1))
 542                        ;;
 543                *)
 544                        # Keep a list of missing prerequisites; restore
 545                        # the negative marker if necessary.
 546                        prerequisite=${negative_prereq:+!}$prerequisite
 547                        if test -z "$missing_prereq"
 548                        then
 549                                missing_prereq=$prerequisite
 550                        else
 551                                missing_prereq="$prerequisite,$missing_prereq"
 552                        fi
 553                esac
 554        done
 555
 556        test $total_prereq = $ok_prereq
 557}
 558
 559test_declared_prereq () {
 560        case ",$test_prereq," in
 561        *,$1,*)
 562                return 0
 563                ;;
 564        esac
 565        return 1
 566}
 567
 568test_verify_prereq () {
 569        test -z "$test_prereq" ||
 570        expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
 571        BUG "'$test_prereq' does not look like a prereq"
 572}
 573
 574test_expect_failure () {
 575        test_start_
 576        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 577        test "$#" = 2 ||
 578        BUG "not 2 or 3 parameters to test-expect-failure"
 579        test_verify_prereq
 580        export test_prereq
 581        if ! test_skip "$@"
 582        then
 583                say >&3 "checking known breakage: $2"
 584                if test_run_ "$2" expecting_failure
 585                then
 586                        test_known_broken_ok_ "$1"
 587                else
 588                        test_known_broken_failure_ "$1"
 589                fi
 590        fi
 591        test_finish_
 592}
 593
 594test_expect_success () {
 595        test_start_
 596        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 597        test "$#" = 2 ||
 598        BUG "not 2 or 3 parameters to test-expect-success"
 599        test_verify_prereq
 600        export test_prereq
 601        if ! test_skip "$@"
 602        then
 603                say >&3 "expecting success: $2"
 604                if test_run_ "$2"
 605                then
 606                        test_ok_ "$1"
 607                else
 608                        test_failure_ "$@"
 609                fi
 610        fi
 611        test_finish_
 612}
 613
 614# test_external runs external test scripts that provide continuous
 615# test output about their progress, and succeeds/fails on
 616# zero/non-zero exit code.  It outputs the test output on stdout even
 617# in non-verbose mode, and announces the external script with "# run
 618# <n>: ..." before running it.  When providing relative paths, keep in
 619# mind that all scripts run in "trash directory".
 620# Usage: test_external description command arguments...
 621# Example: test_external 'Perl API' perl ../path/to/test.pl
 622test_external () {
 623        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 624        test "$#" = 3 ||
 625        BUG "not 3 or 4 parameters to test_external"
 626        descr="$1"
 627        shift
 628        test_verify_prereq
 629        export test_prereq
 630        if ! test_skip "$descr" "$@"
 631        then
 632                # Announce the script to reduce confusion about the
 633                # test output that follows.
 634                say_color "" "# run $test_count: $descr ($*)"
 635                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 636                # to be able to use them in script
 637                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 638                # Run command; redirect its stderr to &4 as in
 639                # test_run_, but keep its stdout on our stdout even in
 640                # non-verbose mode.
 641                "$@" 2>&4
 642                if test "$?" = 0
 643                then
 644                        if test $test_external_has_tap -eq 0; then
 645                                test_ok_ "$descr"
 646                        else
 647                                say_color "" "# test_external test $descr was ok"
 648                                test_success=$(($test_success + 1))
 649                        fi
 650                else
 651                        if test $test_external_has_tap -eq 0; then
 652                                test_failure_ "$descr" "$@"
 653                        else
 654                                say_color error "# test_external test $descr failed: $@"
 655                                test_failure=$(($test_failure + 1))
 656                        fi
 657                fi
 658        fi
 659}
 660
 661# Like test_external, but in addition tests that the command generated
 662# no output on stderr.
 663test_external_without_stderr () {
 664        # The temporary file has no (and must have no) security
 665        # implications.
 666        tmp=${TMPDIR:-/tmp}
 667        stderr="$tmp/git-external-stderr.$$.tmp"
 668        test_external "$@" 4> "$stderr"
 669        test -f "$stderr" || error "Internal error: $stderr disappeared."
 670        descr="no stderr: $1"
 671        shift
 672        say >&3 "# expecting no stderr from previous command"
 673        if test ! -s "$stderr"
 674        then
 675                rm "$stderr"
 676
 677                if test $test_external_has_tap -eq 0; then
 678                        test_ok_ "$descr"
 679                else
 680                        say_color "" "# test_external_without_stderr test $descr was ok"
 681                        test_success=$(($test_success + 1))
 682                fi
 683        else
 684                if test "$verbose" = t
 685                then
 686                        output=$(echo; echo "# Stderr is:"; cat "$stderr")
 687                else
 688                        output=
 689                fi
 690                # rm first in case test_failure exits.
 691                rm "$stderr"
 692                if test $test_external_has_tap -eq 0; then
 693                        test_failure_ "$descr" "$@" "$output"
 694                else
 695                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 696                        test_failure=$(($test_failure + 1))
 697                fi
 698        fi
 699}
 700
 701# debugging-friendly alternatives to "test [-f|-d|-e]"
 702# The commands test the existence or non-existence of $1. $2 can be
 703# given to provide a more precise diagnosis.
 704test_path_is_file () {
 705        if ! test -f "$1"
 706        then
 707                echo "File $1 doesn't exist. $2"
 708                false
 709        fi
 710}
 711
 712test_path_is_dir () {
 713        if ! test -d "$1"
 714        then
 715                echo "Directory $1 doesn't exist. $2"
 716                false
 717        fi
 718}
 719
 720test_path_exists () {
 721        if ! test -e "$1"
 722        then
 723                echo "Path $1 doesn't exist. $2"
 724                false
 725        fi
 726}
 727
 728# Check if the directory exists and is empty as expected, barf otherwise.
 729test_dir_is_empty () {
 730        test_path_is_dir "$1" &&
 731        if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
 732        then
 733                echo "Directory '$1' is not empty, it contains:"
 734                ls -la "$1"
 735                return 1
 736        fi
 737}
 738
 739# Check if the file exists and has a size greater than zero
 740test_file_not_empty () {
 741        if ! test -s "$1"
 742        then
 743                echo "'$1' is not a non-empty file."
 744                false
 745        fi
 746}
 747
 748test_path_is_missing () {
 749        if test -e "$1"
 750        then
 751                echo "Path exists:"
 752                ls -ld "$1"
 753                if test $# -ge 1
 754                then
 755                        echo "$*"
 756                fi
 757                false
 758        fi
 759}
 760
 761# test_line_count checks that a file has the number of lines it
 762# ought to. For example:
 763#
 764#       test_expect_success 'produce exactly one line of output' '
 765#               do something >output &&
 766#               test_line_count = 1 output
 767#       '
 768#
 769# is like "test $(wc -l <output) = 1" except that it passes the
 770# output through when the number of lines is wrong.
 771
 772test_line_count () {
 773        if test $# != 3
 774        then
 775                BUG "not 3 parameters to test_line_count"
 776        elif ! test $(wc -l <"$3") "$1" "$2"
 777        then
 778                echo "test_line_count: line count for $3 !$1 $2"
 779                cat "$3"
 780                return 1
 781        fi
 782}
 783
 784# Returns success if a comma separated string of keywords ($1) contains a
 785# given keyword ($2).
 786# Examples:
 787# `list_contains "foo,bar" bar` returns 0
 788# `list_contains "foo" bar` returns 1
 789
 790list_contains () {
 791        case ",$1," in
 792        *,$2,*)
 793                return 0
 794                ;;
 795        esac
 796        return 1
 797}
 798
 799# This is not among top-level (test_expect_success | test_expect_failure)
 800# but is a prefix that can be used in the test script, like:
 801#
 802#       test_expect_success 'complain and die' '
 803#           do something &&
 804#           do something else &&
 805#           test_must_fail git checkout ../outerspace
 806#       '
 807#
 808# Writing this as "! git checkout ../outerspace" is wrong, because
 809# the failure could be due to a segv.  We want a controlled failure.
 810#
 811# Accepts the following options:
 812#
 813#   ok=<signal-name>[,<...>]:
 814#     Don't treat an exit caused by the given signal as error.
 815#     Multiple signals can be specified as a comma separated list.
 816#     Currently recognized signal names are: sigpipe, success.
 817#     (Don't use 'success', use 'test_might_fail' instead.)
 818
 819test_must_fail () {
 820        case "$1" in
 821        ok=*)
 822                _test_ok=${1#ok=}
 823                shift
 824                ;;
 825        *)
 826                _test_ok=
 827                ;;
 828        esac
 829        "$@" 2>&7
 830        exit_code=$?
 831        if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
 832        then
 833                echo >&4 "test_must_fail: command succeeded: $*"
 834                return 1
 835        elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
 836        then
 837                return 0
 838        elif test $exit_code -gt 129 && test $exit_code -le 192
 839        then
 840                echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
 841                return 1
 842        elif test $exit_code -eq 127
 843        then
 844                echo >&4 "test_must_fail: command not found: $*"
 845                return 1
 846        elif test $exit_code -eq 126
 847        then
 848                echo >&4 "test_must_fail: valgrind error: $*"
 849                return 1
 850        fi
 851        return 0
 852} 7>&2 2>&4
 853
 854# Similar to test_must_fail, but tolerates success, too.  This is
 855# meant to be used in contexts like:
 856#
 857#       test_expect_success 'some command works without configuration' '
 858#               test_might_fail git config --unset all.configuration &&
 859#               do something
 860#       '
 861#
 862# Writing "git config --unset all.configuration || :" would be wrong,
 863# because we want to notice if it fails due to segv.
 864#
 865# Accepts the same options as test_must_fail.
 866
 867test_might_fail () {
 868        test_must_fail ok=success "$@" 2>&7
 869} 7>&2 2>&4
 870
 871# Similar to test_must_fail and test_might_fail, but check that a
 872# given command exited with a given exit code. Meant to be used as:
 873#
 874#       test_expect_success 'Merge with d/f conflicts' '
 875#               test_expect_code 1 git merge "merge msg" B master
 876#       '
 877
 878test_expect_code () {
 879        want_code=$1
 880        shift
 881        "$@" 2>&7
 882        exit_code=$?
 883        if test $exit_code = $want_code
 884        then
 885                return 0
 886        fi
 887
 888        echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 889        return 1
 890} 7>&2 2>&4
 891
 892# test_cmp is a helper function to compare actual and expected output.
 893# You can use it like:
 894#
 895#       test_expect_success 'foo works' '
 896#               echo expected >expected &&
 897#               foo >actual &&
 898#               test_cmp expected actual
 899#       '
 900#
 901# This could be written as either "cmp" or "diff -u", but:
 902# - cmp's output is not nearly as easy to read as diff -u
 903# - not all diff versions understand "-u"
 904
 905test_cmp() {
 906        $GIT_TEST_CMP "$@"
 907}
 908
 909# Check that the given config key has the expected value.
 910#
 911#    test_cmp_config [-C <dir>] <expected-value>
 912#                    [<git-config-options>...] <config-key>
 913#
 914# for example to check that the value of core.bar is foo
 915#
 916#    test_cmp_config foo core.bar
 917#
 918test_cmp_config() {
 919        local GD &&
 920        if test "$1" = "-C"
 921        then
 922                shift &&
 923                GD="-C $1" &&
 924                shift
 925        fi &&
 926        printf "%s\n" "$1" >expect.config &&
 927        shift &&
 928        git $GD config "$@" >actual.config &&
 929        test_cmp expect.config actual.config
 930}
 931
 932# test_cmp_bin - helper to compare binary files
 933
 934test_cmp_bin() {
 935        cmp "$@"
 936}
 937
 938# Use this instead of test_cmp to compare files that contain expected and
 939# actual output from git commands that can be translated.  When running
 940# under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
 941# results.
 942test_i18ncmp () {
 943        ! test_have_prereq C_LOCALE_OUTPUT || test_cmp "$@"
 944}
 945
 946# Use this instead of "grep expected-string actual" to see if the
 947# output from a git command that can be translated either contains an
 948# expected string, or does not contain an unwanted one.  When running
 949# under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
 950# results.
 951test_i18ngrep () {
 952        eval "last_arg=\${$#}"
 953
 954        test -f "$last_arg" ||
 955        BUG "test_i18ngrep requires a file to read as the last parameter"
 956
 957        if test $# -lt 2 ||
 958           { test "x!" = "x$1" && test $# -lt 3 ; }
 959        then
 960                BUG "too few parameters to test_i18ngrep"
 961        fi
 962
 963        if test_have_prereq !C_LOCALE_OUTPUT
 964        then
 965                # pretend success
 966                return 0
 967        fi
 968
 969        if test "x!" = "x$1"
 970        then
 971                shift
 972                ! grep "$@" && return 0
 973
 974                echo >&4 "error: '! grep $@' did find a match in:"
 975        else
 976                grep "$@" && return 0
 977
 978                echo >&4 "error: 'grep $@' didn't find a match in:"
 979        fi
 980
 981        if test -s "$last_arg"
 982        then
 983                cat >&4 "$last_arg"
 984        else
 985                echo >&4 "<File '$last_arg' is empty>"
 986        fi
 987
 988        return 1
 989}
 990
 991# Call any command "$@" but be more verbose about its
 992# failure. This is handy for commands like "test" which do
 993# not output anything when they fail.
 994verbose () {
 995        "$@" && return 0
 996        echo >&4 "command failed: $(git rev-parse --sq-quote "$@")"
 997        return 1
 998}
 999
1000# Check if the file expected to be empty is indeed empty, and barfs
1001# otherwise.
1002
1003test_must_be_empty () {
1004        test_path_is_file "$1" &&
1005        if test -s "$1"
1006        then
1007                echo "'$1' is not empty, it contains:"
1008                cat "$1"
1009                return 1
1010        fi
1011}
1012
1013# Tests that its two parameters refer to the same revision
1014test_cmp_rev () {
1015        if test $# != 2
1016        then
1017                error "bug in the test script: test_cmp_rev requires two revisions, but got $#"
1018        else
1019                local r1 r2
1020                r1=$(git rev-parse --verify "$1") &&
1021                r2=$(git rev-parse --verify "$2") &&
1022                if test "$r1" != "$r2"
1023                then
1024                        cat >&4 <<-EOF
1025                        error: two revisions point to different objects:
1026                          '$1': $r1
1027                          '$2': $r2
1028                        EOF
1029                        return 1
1030                fi
1031        fi
1032}
1033
1034# Print a sequence of integers in increasing order, either with
1035# two arguments (start and end):
1036#
1037#     test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
1038#
1039# or with one argument (end), in which case it starts counting
1040# from 1.
1041
1042test_seq () {
1043        case $# in
1044        1)      set 1 "$@" ;;
1045        2)      ;;
1046        *)      BUG "not 1 or 2 parameters to test_seq" ;;
1047        esac
1048        test_seq_counter__=$1
1049        while test "$test_seq_counter__" -le "$2"
1050        do
1051                echo "$test_seq_counter__"
1052                test_seq_counter__=$(( $test_seq_counter__ + 1 ))
1053        done
1054}
1055
1056# This function can be used to schedule some commands to be run
1057# unconditionally at the end of the test to restore sanity:
1058#
1059#       test_expect_success 'test core.capslock' '
1060#               git config core.capslock true &&
1061#               test_when_finished "git config --unset core.capslock" &&
1062#               hello world
1063#       '
1064#
1065# That would be roughly equivalent to
1066#
1067#       test_expect_success 'test core.capslock' '
1068#               git config core.capslock true &&
1069#               hello world
1070#               git config --unset core.capslock
1071#       '
1072#
1073# except that the greeting and config --unset must both succeed for
1074# the test to pass.
1075#
1076# Note that under --immediate mode, no clean-up is done to help diagnose
1077# what went wrong.
1078
1079test_when_finished () {
1080        # We cannot detect when we are in a subshell in general, but by
1081        # doing so on Bash is better than nothing (the test will
1082        # silently pass on other shells).
1083        test "${BASH_SUBSHELL-0}" = 0 ||
1084        BUG "test_when_finished does nothing in a subshell"
1085        test_cleanup="{ $*
1086                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
1087}
1088
1089# This function can be used to schedule some commands to be run
1090# unconditionally at the end of the test script, e.g. to stop a daemon:
1091#
1092#       test_expect_success 'test git daemon' '
1093#               git daemon &
1094#               daemon_pid=$! &&
1095#               test_atexit 'kill $daemon_pid' &&
1096#               hello world
1097#       '
1098#
1099# The commands will be executed before the trash directory is removed,
1100# i.e. the atexit commands will still be able to access any pidfiles or
1101# socket files.
1102#
1103# Note that these commands will be run even when a test script run
1104# with '--immediate' fails.  Be careful with your atexit commands to
1105# minimize any changes to the failed state.
1106
1107test_atexit () {
1108        # We cannot detect when we are in a subshell in general, but by
1109        # doing so on Bash is better than nothing (the test will
1110        # silently pass on other shells).
1111        test "${BASH_SUBSHELL-0}" = 0 ||
1112        error "bug in test script: test_atexit does nothing in a subshell"
1113        test_atexit_cleanup="{ $*
1114                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_atexit_cleanup"
1115}
1116
1117# Most tests can use the created repository, but some may need to create more.
1118# Usage: test_create_repo <directory>
1119test_create_repo () {
1120        test "$#" = 1 ||
1121        BUG "not 1 parameter to test-create-repo"
1122        repo="$1"
1123        mkdir -p "$repo"
1124        (
1125                cd "$repo" || error "Cannot setup test environment"
1126                "${GIT_TEST_INSTALLED:-$GIT_EXEC_PATH}/git$X" init \
1127                        "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
1128                error "cannot run git init -- have you built things yet?"
1129                mv .git/hooks .git/hooks-disabled
1130        ) || exit
1131}
1132
1133# This function helps on symlink challenged file systems when it is not
1134# important that the file system entry is a symbolic link.
1135# Use test_ln_s_add instead of "ln -s x y && git add y" to add a
1136# symbolic link entry y to the index.
1137
1138test_ln_s_add () {
1139        if test_have_prereq SYMLINKS
1140        then
1141                ln -s "$1" "$2" &&
1142                git update-index --add "$2"
1143        else
1144                printf '%s' "$1" >"$2" &&
1145                ln_s_obj=$(git hash-object -w "$2") &&
1146                git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
1147                # pick up stat info from the file
1148                git update-index "$2"
1149        fi
1150}
1151
1152# This function writes out its parameters, one per line
1153test_write_lines () {
1154        printf "%s\n" "$@"
1155}
1156
1157perl () {
1158        command "$PERL_PATH" "$@" 2>&7
1159} 7>&2 2>&4
1160
1161# Is the value one of the various ways to spell a boolean true/false?
1162test_normalize_bool () {
1163        git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
1164}
1165
1166# Given a variable $1, normalize the value of it to one of "true",
1167# "false", or "auto" and store the result to it.
1168#
1169#     test_tristate GIT_TEST_HTTPD
1170#
1171# A variable set to an empty string is set to 'false'.
1172# A variable set to 'false' or 'auto' keeps its value.
1173# Anything else is set to 'true'.
1174# An unset variable defaults to 'auto'.
1175#
1176# The last rule is to allow people to set the variable to an empty
1177# string and export it to decline testing the particular feature
1178# for versions both before and after this change.  We used to treat
1179# both unset and empty variable as a signal for "do not test" and
1180# took any non-empty string as "please test".
1181
1182test_tristate () {
1183        if eval "test x\"\${$1+isset}\" = xisset"
1184        then
1185                # explicitly set
1186                eval "
1187                        case \"\$$1\" in
1188                        '')     $1=false ;;
1189                        auto)   ;;
1190                        *)      $1=\$(test_normalize_bool \$$1 || echo true) ;;
1191                        esac
1192                "
1193        else
1194                eval "$1=auto"
1195        fi
1196}
1197
1198# Exit the test suite, either by skipping all remaining tests or by
1199# exiting with an error. If "$1" is "auto", we then we assume we were
1200# opportunistically trying to set up some tests and we skip. If it is
1201# "true", then we report a failure.
1202#
1203# The error/skip message should be given by $2.
1204#
1205test_skip_or_die () {
1206        case "$1" in
1207        auto)
1208                skip_all=$2
1209                test_done
1210                ;;
1211        true)
1212                error "$2"
1213                ;;
1214        *)
1215                error "BUG: test tristate is '$1' (real error: $2)"
1216        esac
1217}
1218
1219# The following mingw_* functions obey POSIX shell syntax, but are actually
1220# bash scripts, and are meant to be used only with bash on Windows.
1221
1222# A test_cmp function that treats LF and CRLF equal and avoids to fork
1223# diff when possible.
1224mingw_test_cmp () {
1225        # Read text into shell variables and compare them. If the results
1226        # are different, use regular diff to report the difference.
1227        local test_cmp_a= test_cmp_b=
1228
1229        # When text came from stdin (one argument is '-') we must feed it
1230        # to diff.
1231        local stdin_for_diff=
1232
1233        # Since it is difficult to detect the difference between an
1234        # empty input file and a failure to read the files, we go straight
1235        # to diff if one of the inputs is empty.
1236        if test -s "$1" && test -s "$2"
1237        then
1238                # regular case: both files non-empty
1239                mingw_read_file_strip_cr_ test_cmp_a <"$1"
1240                mingw_read_file_strip_cr_ test_cmp_b <"$2"
1241        elif test -s "$1" && test "$2" = -
1242        then
1243                # read 2nd file from stdin
1244                mingw_read_file_strip_cr_ test_cmp_a <"$1"
1245                mingw_read_file_strip_cr_ test_cmp_b
1246                stdin_for_diff='<<<"$test_cmp_b"'
1247        elif test "$1" = - && test -s "$2"
1248        then
1249                # read 1st file from stdin
1250                mingw_read_file_strip_cr_ test_cmp_a
1251                mingw_read_file_strip_cr_ test_cmp_b <"$2"
1252                stdin_for_diff='<<<"$test_cmp_a"'
1253        fi
1254        test -n "$test_cmp_a" &&
1255        test -n "$test_cmp_b" &&
1256        test "$test_cmp_a" = "$test_cmp_b" ||
1257        eval "diff -u \"\$@\" $stdin_for_diff"
1258}
1259
1260# $1 is the name of the shell variable to fill in
1261mingw_read_file_strip_cr_ () {
1262        # Read line-wise using LF as the line separator
1263        # and use IFS to strip CR.
1264        local line
1265        while :
1266        do
1267                if IFS=$'\r' read -r -d $'\n' line
1268                then
1269                        # good
1270                        line=$line$'\n'
1271                else
1272                        # we get here at EOF, but also if the last line
1273                        # was not terminated by LF; in the latter case,
1274                        # some text was read
1275                        if test -z "$line"
1276                        then
1277                                # EOF, really
1278                                break
1279                        fi
1280                fi
1281                eval "$1=\$$1\$line"
1282        done
1283}
1284
1285# Like "env FOO=BAR some-program", but run inside a subshell, which means
1286# it also works for shell functions (though those functions cannot impact
1287# the environment outside of the test_env invocation).
1288test_env () {
1289        (
1290                while test $# -gt 0
1291                do
1292                        case "$1" in
1293                        *=*)
1294                                eval "${1%%=*}=\${1#*=}"
1295                                eval "export ${1%%=*}"
1296                                shift
1297                                ;;
1298                        *)
1299                                "$@" 2>&7
1300                                exit
1301                                ;;
1302                        esac
1303                done
1304        )
1305} 7>&2 2>&4
1306
1307# Returns true if the numeric exit code in "$2" represents the expected signal
1308# in "$1". Signals should be given numerically.
1309test_match_signal () {
1310        if test "$2" = "$((128 + $1))"
1311        then
1312                # POSIX
1313                return 0
1314        elif test "$2" = "$((256 + $1))"
1315        then
1316                # ksh
1317                return 0
1318        fi
1319        return 1
1320}
1321
1322# Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1323test_copy_bytes () {
1324        perl -e '
1325                my $len = $ARGV[1];
1326                while ($len > 0) {
1327                        my $s;
1328                        my $nread = sysread(STDIN, $s, $len);
1329                        die "cannot read: $!" unless defined($nread);
1330                        last unless $nread;
1331                        print $s;
1332                        $len -= $nread;
1333                }
1334        ' - "$1"
1335}
1336
1337# run "$@" inside a non-git directory
1338nongit () {
1339        test -d non-repo ||
1340        mkdir non-repo ||
1341        return 1
1342
1343        (
1344                GIT_CEILING_DIRECTORIES=$(pwd) &&
1345                export GIT_CEILING_DIRECTORIES &&
1346                cd non-repo &&
1347                "$@" 2>&7
1348        )
1349} 7>&2 2>&4
1350
1351# convert stdin to pktline representation; note that empty input becomes an
1352# empty packet, not a flush packet (for that you can just print 0000 yourself).
1353packetize() {
1354        cat >packetize.tmp &&
1355        len=$(wc -c <packetize.tmp) &&
1356        printf '%04x%s' "$(($len + 4))" &&
1357        cat packetize.tmp &&
1358        rm -f packetize.tmp
1359}
1360
1361# Parse the input as a series of pktlines, writing the result to stdout.
1362# Sideband markers are removed automatically, and the output is routed to
1363# stderr if appropriate.
1364#
1365# NUL bytes are converted to "\\0" for ease of parsing with text tools.
1366depacketize () {
1367        perl -e '
1368                while (read(STDIN, $len, 4) == 4) {
1369                        if ($len eq "0000") {
1370                                print "FLUSH\n";
1371                        } else {
1372                                read(STDIN, $buf, hex($len) - 4);
1373                                $buf =~ s/\0/\\0/g;
1374                                if ($buf =~ s/^[\x2\x3]//) {
1375                                        print STDERR $buf;
1376                                } else {
1377                                        $buf =~ s/^\x1//;
1378                                        print $buf;
1379                                }
1380                        }
1381                }
1382        '
1383}
1384
1385# Converts base-16 data into base-8. The output is given as a sequence of
1386# escaped octals, suitable for consumption by 'printf'.
1387hex2oct () {
1388        perl -ne 'printf "\\%03o", hex for /../g'
1389}
1390
1391# Set the hash algorithm in use to $1.  Only useful when testing the testsuite.
1392test_set_hash () {
1393        test_hash_algo="$1"
1394}
1395
1396# Detect the hash algorithm in use.
1397test_detect_hash () {
1398        # Currently we only support SHA-1, but in the future this function will
1399        # actually detect the algorithm in use.
1400        test_hash_algo='sha1'
1401}
1402
1403# Load common hash metadata and common placeholder object IDs for use with
1404# test_oid.
1405test_oid_init () {
1406        test -n "$test_hash_algo" || test_detect_hash &&
1407        test_oid_cache <"$TEST_DIRECTORY/oid-info/hash-info" &&
1408        test_oid_cache <"$TEST_DIRECTORY/oid-info/oid"
1409}
1410
1411# Load key-value pairs from stdin suitable for use with test_oid.  Blank lines
1412# and lines starting with "#" are ignored.  Keys must be shell identifier
1413# characters.
1414#
1415# Examples:
1416# rawsz sha1:20
1417# rawsz sha256:32
1418test_oid_cache () {
1419        local tag rest k v &&
1420
1421        { test -n "$test_hash_algo" || test_detect_hash; } &&
1422        while read tag rest
1423        do
1424                case $tag in
1425                \#*)
1426                        continue;;
1427                ?*)
1428                        # non-empty
1429                        ;;
1430                *)
1431                        # blank line
1432                        continue;;
1433                esac &&
1434
1435                k="${rest%:*}" &&
1436                v="${rest#*:}" &&
1437
1438                if ! expr "$k" : '[a-z0-9][a-z0-9]*$' >/dev/null
1439                then
1440                        BUG 'bad hash algorithm'
1441                fi &&
1442                eval "test_oid_${k}_$tag=\"\$v\""
1443        done
1444}
1445
1446# Look up a per-hash value based on a key ($1).  The value must have been loaded
1447# by test_oid_init or test_oid_cache.
1448test_oid () {
1449        local var="test_oid_${test_hash_algo}_$1" &&
1450
1451        # If the variable is unset, we must be missing an entry for this
1452        # key-hash pair, so exit with an error.
1453        if eval "test -z \"\${$var+set}\""
1454        then
1455                BUG "undefined key '$1'"
1456        fi &&
1457        eval "printf '%s' \"\${$var}\""
1458}
1459
1460# Choose a port number based on the test script's number and store it in
1461# the given variable name, unless that variable already contains a number.
1462test_set_port () {
1463        local var=$1 port
1464
1465        if test $# -ne 1 || test -z "$var"
1466        then
1467                BUG "test_set_port requires a variable name"
1468        fi
1469
1470        eval port=\$$var
1471        case "$port" in
1472        "")
1473                # No port is set in the given env var, use the test
1474                # number as port number instead.
1475                # Remove not only the leading 't', but all leading zeros
1476                # as well, so the arithmetic below won't (mis)interpret
1477                # a test number like '0123' as an octal value.
1478                port=${this_test#${this_test%%[1-9]*}}
1479                if test "${port:-0}" -lt 1024
1480                then
1481                        # root-only port, use a larger one instead.
1482                        port=$(($port + 10000))
1483                fi
1484                ;;
1485        *[!0-9]*|0*)
1486                error >&7 "invalid port number: $port"
1487                ;;
1488        *)
1489                # The user has specified the port.
1490                ;;
1491        esac
1492
1493        # Make sure that parallel '--stress' test jobs get different
1494        # ports.
1495        port=$(($port + ${GIT_TEST_STRESS_JOB_NR:-0}))
1496        eval $var=$port
1497}